import '@clr/icons';
import '@clr/icons/shapes/all-shapes';
import { HttpClientModule } from '@angular/common/http';
import { CommonModule } from '@angular/common';
import { utils, writeFile } from 'xlsx';
import { ProgressbarModule, TabsModule } from 'ngx-bootstrap';
import { NgSelectModule } from '@ng-select/ng-select';
import alasql from 'alasql';
import { ChartsModule } from 'ng2-charts';
import { BarChartModule, LineChartModule, NumberCardModule, PieChartModule } from '@swimlane/ngx-charts';
import { ClarityModule, ClrCommonFormsModule, ClrInputModule } from '@clr/angular';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { Injectable, Component, EventEmitter, Input, Output, NgModule, ViewChild, defineInjectable } from '@angular/core';
import { BrowserAnimationsModule, NoopAnimationsModule } from '@angular/platform-browser/animations';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class WikigiocoLibService {
    constructor() { }
}
WikigiocoLibService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
WikigiocoLibService.ctorParameters = () => [];
/** @nocollapse */ WikigiocoLibService.ngInjectableDef = defineInjectable({ factory: function WikigiocoLibService_Factory() { return new WikigiocoLibService(); }, token: WikigiocoLibService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class WikigiocoLibComponent {
    constructor() { }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
WikigiocoLibComponent.decorators = [
    { type: Component, args: [{
                selector: 'wkg-wikigioco-lib',
                template: `
    <p>
      wikigioco-lib works!
    </p>
  `
            }] }
];
/** @nocollapse */
WikigiocoLibComponent.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MComponent {
    /**
     * @param {?} _component
     */
    constructor(_component) {
        this.label = 'ROOT';
        this.type = 'ROOT';
        this.children = [];
        this.groups = [];
        this.groupsPrototype = [];
        if (_component === null) {
            return;
        }
        this.label = _component.label;
        this.id = _component.id;
        this.type = _component.type;
        this.component = _component;
        this.value = _component.value;
        if (_component.group !== undefined) {
            _component.group.forEach((/**
             * @param {?} item
             * @return {?}
             */
            (item) => {
                /** @type {?} */
                const app = new MComponent(item);
                this.groups.push(app);
                this.addChildren(item);
            }));
        }
        if (_component.groupPrototype !== undefined) {
            _component.groupPrototype.forEach((/**
             * @param {?} item
             * @return {?}
             */
            (item) => {
                /** @type {?} */
                const app = new MComponent(item);
                this.groupsPrototype.push(app);
                this.addChildren(item);
            }));
        }
    }
    /**
     * @return {?}
     */
    newRow() {
        this.component.groupPrototype.forEach((/**
         * @param {?} item
         * @return {?}
         */
        (item) => {
            this.addChildren(item);
        }));
    }
    /**
     * @param {?} _component
     * @return {?}
     */
    addChildren(_component) {
        /** @type {?} */
        const app = new MComponent(_component);
        this.children.push(app);
    }
    /**
     * @return {?}
     */
    dump() {
        console.log(this.component.label + ' = ' + this.value + ', ' + this.component.value);
        if (this.groups !== undefined) {
            this.groups.forEach((/**
             * @param {?} item
             * @return {?}
             */
            (item) => {
                item.dump();
            }));
        }
        if (this.groupsPrototype !== undefined) {
            this.groupsPrototype.forEach((/**
             * @param {?} item
             * @return {?}
             */
            (item) => {
                item.dump();
            }));
        }
    }
    /**
     * @return {?}
     */
    isEmpty() {
        /** @type {?} */
        let justOne = true;
        if (this.children !== undefined && this.children.length > 0) {
            this.children.forEach((/**
             * @param {?} item
             * @return {?}
             */
            (item) => {
                if (!item.isEmpty()) {
                    justOne = false;
                }
            }));
        }
        else if (this.value !== undefined) {
            justOne = false;
        }
        return justOne;
    }
    /**
     * @return {?}
     */
    getJson() {
        if (this.isEmpty()) {
            return '';
        }
        /** @type {?} */
        let count = 0;
        /** @type {?} */
        let s = '';
        switch (this.type) {
            case 'ARRAY':
            case 'ROOT':
                s += '[';
                this.children.forEach((/**
                 * @param {?} item
                 * @return {?}
                 */
                (item) => {
                    if (!item.isEmpty()) {
                        /** @type {?} */
                        const temp = item.getJson();
                        if (count > 0) {
                            s += ',';
                        }
                        s += temp;
                        count++;
                    }
                }));
                s += ']';
                break;
            case 'GROUP':
                s += '{';
                this.children.forEach((/**
                 * @param {?} item
                 * @return {?}
                 */
                (item) => {
                    if (!item.isEmpty()) {
                        /** @type {?} */
                        const temp = item.getJson();
                        if (count > 0) {
                            s += ',';
                        }
                        s += temp;
                        count++;
                    }
                }));
                s += '}';
                break;
            default:
                s += this.value;
                count++;
                break;
        }
        if (count > 0) {
            if (this.id === undefined) {
                return s;
            }
            return this.id + ': ' + s;
        }
        return '';
    }
    /**
     * @return {?}
     */
    getJsonChildren() {
        /** @type {?} */
        let s = this.id + ': ' + this.value;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class GObjectComponent {
    constructor() {
        this.onChange = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        console.log('Component  (' + this.component.id + ',' + this.component.type + ')');
    }
    /**
     * @param {?} event
     * @return {?}
     */
    focusGained(event) {
        console.log(event);
    }
    /**
     * @param {?} newValue
     * @return {?}
     */
    valueChange(newValue) {
        this.component.value = newValue;
        this.onChange.emit(this.component);
    }
}
GObjectComponent.decorators = [
    { type: Component, args: [{
                selector: 'wkg-gobject',
                template: "<div class=\"row\" ngSwitch=\"{{component.type}}\">\n  <clr-input-container *ngSwitchCase=\"'TEXT'\">\n    <label>{{component.label}}</label>\n    <input placeholder=\"{{component.component.placeHolder}}\" clrInput [(ngModel)]=\"component.value\" maxlength=\"{{component.component.maxLength}}\" name=\"{{component.id}}\" required (ngModelChange)=\"valueChange($event)\"/>\n    <clr-control-helper>Helper text</clr-control-helper>\n    <clr-control-error>This field is required!</clr-control-error>\n  </clr-input-container>\n\n  <clr-input-container *ngSwitchCase=\"'NUMBER'\">\n    <label>{{component.label}}</label>\n    <input placeholder=\"{{component.component.placeHolder}}\" type=\"number\"  min=\"{{component.component.min}}\" max=\"{{component.component.max}}\" maxlength=\"{{component.component.maxLength}}\"clrInput [(ngModel)]=\"component.value\" name=\"{{component.id}}\" (ngModelChange)=\"valueChange($event)\" required/>\n    <clr-control-helper>Helper text</clr-control-helper>\n    <clr-control-error>This field is required!</clr-control-error>\n  </clr-input-container>\n\n  <clr-input-container *ngSwitchCase=\"'EMAIL'\">\n    <label>{{component.label}}</label>\n    <input placeholder=\"{{component.component.placeHolder}}\" type=\"email\"  min=\"{{component.component.min}}\" max=\"{{component.component.max}}\" maxlength=\"{{component.component.maxLength}}\"clrInput [(ngModel)]=\"component.value\" name=\"{{component.id}}\" required(ngModelChange)=\"valueChange($event)\"/>\n    <clr-control-helper>Helper text</clr-control-helper>\n    <clr-control-error>This field is required!</clr-control-error>\n  </clr-input-container>\n\n\n\n  <clr-checkbox-container *ngSwitchCase=\"'CHECKBOX'\">\n    <label>{{component.label}}</label>\n    <clr-checkbox-wrapper>\n      <input type=\"checkbox\" clrCheckbox [ngModel]=\"component.value\" value=\"{{component.value}}\" name=\"{{component.id}}\" id=\"{{component.id}}\" (ngModelChange)=\"valueChange($event)\"/>\n      <label>{{component.component.placeHolder}}</label>\n    </clr-checkbox-wrapper>\n    <clr-control-helper>Helper text that shows while it is pristine and valid</clr-control-helper>\n    <clr-control-error>Error message that appears after focus is lost and control is invalid</clr-control-error>\n  </clr-checkbox-container>\n  <clr-password-container *ngSwitchCase=\"'PASSWORD'\">\n    <label class=\"clr-col-xs-12 clr-col-md-4\">{{component.label}}</label>\n    <input clrPassword placeholder=\"{{component.component.placeHolder}}\" name=\"{{component.id}}\"\n           [(ngModel)]=\"component.value\" (ngModelChange)=\"valueChange($event)\"/>\n  </clr-password-container>\n  <clr-select-container *ngSwitchCase=\"'SELECT'\">\n    <label>{{component.label}}</label>\n    <select clrSelect name=\"{{component.id}}\" [(ngModel)]=\"component.value\" (ngModelChange)=\"valueChange($event)\" (focus)=\"focusGained($event)\">\n      <option value=\"{{v.value}}\" *ngFor=\"let v of component.component.options\">{{v.label}}</option>\n    </select>\n  </clr-select-container>\n\n  <clr-textarea-container *ngSwitchCase=\"'TEXTAREA'\">\n    <label>{{component.label}}</label>\n    <textarea clrTextarea [(ngModel)]=\"component.value\" name=\"{{component.id}}\" required (ngModelChange)=\"valueChange($event)\"></textarea>\n  </clr-textarea-container>\n\n  <div class=\"form-block\" *ngSwitchCase=\"'DATETIME'\">\n    <div class=\"form-group\">\n      <label for=\"{{component.id}}\">{{component.label}}</label>\n      <input type=\"date\" id=\"{{component.id}}\" name=\"{{component.id}}\" (ngModelChange)=\"valueChange($event)\"\n             [(ngModel)]=\"component.value\" clrDate>\n    </div>\n  </div>\n\n  <clr-input-container *ngSwitchDefault>\n    <p>Default</p>\n    <label>{{component.label}}</label>\n    <input placeholder=\"{{component.component.placeHolder}}\" clrInput [(ngModel)]=\"component.value\" maxlength=\"{{component.component.maxLength}}\" name=\"{{component.id}}\" required (ngModelChange)=\"valueChange($event)\"/>\n    <clr-control-helper>Helper text</clr-control-helper>\n    <clr-control-error>This field is required!</clr-control-error>\n  </clr-input-container>\n</div>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
GObjectComponent.ctorParameters = () => [];
GObjectComponent.propDecorators = {
    component: [{ type: Input }],
    onChange: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class GlistComponent {
    constructor() {
        this.onChange = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        console.log('List - ' + this.component.label);
    }
    /**
     * @param {?} event
     * @return {?}
     */
    valueChange(event) {
        this.onChange.emit(event);
    }
}
GlistComponent.decorators = [
    { type: Component, args: [{
                selector: 'wkg-glist',
                template: "<div class=\"row\" ngSwitch=\"{{component.type}}\">\n  <div class=\"card\" *ngSwitchCase=\"'ROOT'\">\n    <div class=\"card-header\">\n      {{component.label}}\n    </div>\n    <div class=\"card-body\">\n      <div *ngFor=\"let cg of component.children\" ngSwitch=\"{{cg.type}}\">\n        <wkg-glist [component]=\"cg\" *ngSwitchDefault (onChange)=\"valueChange($event)\"></wkg-glist>\n      </div>\n    </div>\n  </div>\n  <div class=\"card\" *ngSwitchCase=\"'GROUP'\">\n    <div class=\"card-header\">\n      {{component.label}}\n    </div>\n    <div class=\"card-body\">\n      <div *ngFor=\"let cg of component.children\" ngSwitch=\"{{cg.type}}\">\n        <wkg-glist [component]=\"cg\" *ngSwitchDefault (onChange)=\"valueChange($event)\"></wkg-glist>\n      </div>\n    </div>\n  </div>\n  <div class=\"card\" *ngSwitchCase=\"'ARRAY'\">\n    <div class=\"card-header\">\n      {{component.label}}\n    </div>\n    <div class=\"card-body\">\n      <div *ngFor=\"let cg of component.children\" ngSwitch=\"{{cg.type}}\">\n        <wkg-glist [component]=\"cg\" *ngSwitchDefault (onChange)=\"valueChange($event)\"></wkg-glist>\n      </div>\n    </div>\n    <div class=\"card-footer\">\n      <button (click)=\"component.newRow()\"></button>\n    </div>\n  </div>\n  <wkg-gobject [component]=\"component\" *ngSwitchDefault (onChange)=\"valueChange($event)\"></wkg-gobject>\n</div>\n\n",
                styles: [""]
            }] }
];
/** @nocollapse */
GlistComponent.ctorParameters = () => [];
GlistComponent.propDecorators = {
    component: [{ type: Input }],
    onChange: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class TreeNode {
    /**
     * @param {?} name
     * @param {?} icon
     * @param {?=} object
     * @param {?=} value
     */
    constructor(name, icon, object, value) {
        this._children = [];
        this._name = name;
        this._icon = icon.toLowerCase();
        this._object = object;
        this._expanded = true;
        this._value = value;
    }
    /**
     * @return {?}
     */
    get value() {
        return this._value;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set value(value) {
        this._value = value;
    }
    /**
     * @return {?}
     */
    get name() {
        return this._name;
    }
    /**
     * @param {?} node
     * @return {?}
     */
    addChildren(node) {
        if (this.children === undefined) {
            this.children = [];
        }
        this.children.push(node);
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set name(value) {
        this._name = value;
    }
    /**
     * @return {?}
     */
    get icon() {
        return this._icon;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set icon(value) {
        this._icon = value;
    }
    /**
     * @return {?}
     */
    get object() {
        return this._object;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set object(value) {
        this._object = value;
    }
    /**
     * @return {?}
     */
    get expanded() {
        return this._expanded;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set expanded(value) {
        this._expanded = value;
    }
    /**
     * @return {?}
     */
    get active() {
        return this._active;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set active(value) {
        this._active = value;
    }
    /**
     * @return {?}
     */
    get children() {
        return this._children;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set children(value) {
        this._children = value;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class GtreeComponent {
    constructor() {
        this.tree = new TreeNode('Root', 'icon', null);
        this.onClick = new EventEmitter();
    }
    /**
     * @param {?} node
     * @return {?}
     */
    clickNode(node) {
        node.expanded = !node.expanded;
        this.onClick.emit(node);
        console.log('clicked node: ' + node.name);
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        console.log(JSON.stringify(this.tree.children));
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        this.tree = changes.tree.currentValue;
        //console.log('ON CHANGES LINE CHART');
    }
}
GtreeComponent.decorators = [
    { type: Component, args: [{
                selector: 'wkg-gtree',
                template: "<clr-main-container>\n  <clr-tree-node *ngFor=\"let node of tree.children\">\n    <button\n      (click)=\"clickNode(node)\"\n      class=\"clr-treenode-link\"\n      [class.active]=\"node.active\" class=\"icon\">\n      <clr-icon [attr.shape]=\"node.icon\" [attr.size]=\"12\" size=\"12\" class=\"icon\"></clr-icon>\n      {{node.name}}\n    </button>\n    <ng-template [(clrIfExpanded)]=\"node.expanded\">\n      <clr-tree-node *ngFor=\"let file of node.children\">\n        <button\n          (click)=\"clickNode(file)\"\n          class=\"clr-treenode-link\"\n          [class.active]=\"file.active\" class=\"icon\">\n          <clr-icon [attr.shape]=\"file.icon\" size=\"12\" [attr.size]=\"12\"></clr-icon>\n          {{file.name}}\n\n        </button>\n        <ng-template [(clrIfExpanded)]=\"file.expanded\">\n          <div *ngIf=\"file.object\">\n            <wkg-gobject [component]=\"file.object\"></wkg-gobject>\n          </div>\n          <clr-tree-node *ngFor=\"let leaf of file.children\">\n            <button\n              (click)=\"clickNode(leaf)\"\n              class=\"clr-treenode-link\"\n              [class.active]=\"leaf.active\" class=\"icon\">\n              <clr-icon [attr.shape]=\"leaf.icon\" size=\"12\" [attr.size]=\"12\"></clr-icon>\n              {{leaf.name}}\n              <div *ngIf=\"leaf.object\">\n                <wkg-gobject [component]=\"leaf.object\"></wkg-gobject>\n              </div>\n            </button>\n            <ng-template [(clrIfExpanded)]=\"leaf.expanded\">\n              <clr-tree-node *ngFor=\"let flower of leaf.children\">\n                <button\n                  (click)=\"clickNode(flower)\"\n                  class=\"clr-treenode-link\"\n                  [class.active]=\"flower.active\" class=\"icon\">\n                  <clr-icon [attr.shape]=\"flower.icon\" size=\"12\" [attr.size]=\"12\"></clr-icon>\n                  {{flower.name}}\n                  <div *ngIf=\"flower.object\">\n                    <wkg-gobject [component]=\"flower.object\"></wkg-gobject>\n                  </div>\n                </button>\n              </clr-tree-node>\n            </ng-template>\n          </clr-tree-node>\n        </ng-template>\n      </clr-tree-node>\n    </ng-template>\n  </clr-tree-node>\n</clr-main-container>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
GtreeComponent.ctorParameters = () => [];
GtreeComponent.propDecorators = {
    tree: [{ type: Input }],
    onClick: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class GuiService {
    constructor() {
        this.ICON_ROOT = 'check';
        this.ICON_CHECK = 'check';
        this.ICON_FOLDER = 'folder';
        this.ICON_DATE = 'calendar';
        this.ICON_GROUP = 'step-forward-2';
        this.ICON_NUMBER = 'calculator';
        this.ICON_input = 'pencil';
        this.ICON_LIST = 'list';
        this.ICON_FILE = 'attachment';
        this.ICON_STAR = 'star';
        this.ICON_COMBO = 'filter-2';
        this.ICON_SLIDER = 'slider';
    }
    /**
     * @param {?} _father
     * @param {?} json
     * @return {?}
     */
    elaborate(_father, json) {
        json.forEach((/**
         * @param {?} item
         * @return {?}
         */
        (item) => {
            console.log(JSON.stringify(item));
            /** @type {?} */
            const icon = this.getIcon(item);
            /** @type {?} */
            const treeNode = new TreeNode(item.id, icon, item);
            _father.addChildren(treeNode);
            if (item.group !== undefined) {
                this.elaborate(treeNode, item.group);
            }
            else if (item.groupPrototype !== undefined) {
                this.elaborate(treeNode, item.groupPrototype);
            }
        }));
    }
    /**
     * @param {?} form
     * @param {?=} _father
     * @return {?}
     */
    generateTreeForm(form, _father) {
        if (_father === undefined) {
            _father = new TreeNode('Root', 'icon', null);
        }
        form.children.forEach((/**
         * @param {?} item
         * @return {?}
         */
        (item) => {
            console.log(JSON.stringify(item));
            /** @type {?} */
            const icon = this.getIcon(item);
            /** @type {?} */
            const treeNode = new TreeNode(item.id, icon, item);
            _father.addChildren(treeNode);
            if (item.children !== undefined) {
                item.children.forEach((/**
                 * @param {?} child
                 * @return {?}
                 */
                (child) => {
                    this.generateTreeForm(child, treeNode);
                }));
            }
        }));
        return _father;
    }
    /**
     * @param {?} obj
     * @param {?=} _father
     * @param {?=} _sonArr
     * @return {?}
     */
    generateForm(obj, _father, _sonArr) {
        for (const k in obj) {
            if (Array.isArray(obj[k])) {
                /** @type {?} */
                const app = (/** @type {?} */ (obj[k]));
                /** @type {?} */
                const arrSize = app.length + 1;
                /** @type {?} */
                const cc = {
                    type: 'ARRAY',
                    id: k,
                    label: k.toUpperCase(),
                    initialCount: arrSize,
                    placeholder: k.toUpperCase(),
                    groupPrototype: []
                };
                _father.push(cc);
                this.generateForm(app, cc.groupPrototype, true);
            }
            else if (typeof obj[k] === 'object') {
                /** @type {?} */
                const cc = {
                    type: 'GROUP',
                    id: k,
                    label: k.toUpperCase(),
                    placeholder: k.toUpperCase(),
                    group: []
                };
                if (_sonArr && this.isNumber(k)) {
                    this.generateForm(obj[k], _father);
                }
                else {
                    _father.push(cc);
                    this.generateForm(obj[k], cc.group);
                }
            }
            else {
                /** @type {?} */
                const value = obj[k];
                /** @type {?} */
                let type = 'TEXT';
                // TODO implementare controlli per tipologia
                /*if (isNaN(Number(value))) {
                  inputType = 'number';
                } else */ if (typeof value === 'number') {
                    type = 'NUMBER';
                }
                else if (typeof value === 'boolean') {
                    type = 'CHECKBOX';
                } /* else if (this.isValidDate(value)) {
                  type = 'DATEPICKER';
                }*/
                /* else if (this.isValidDate(value)) {
                          type = 'DATEPICKER';
                        }*/
                /** @type {?} */
                const cc = {
                    type: type,
                    id: k,
                    label: k.toUpperCase(),
                    placeholder: k.toUpperCase()
                };
                _father.push(cc);
            }
        }
    }
    /**
     * @param {?} obj
     * @param {?=} _father
     * @return {?}
     */
    fillJsonForm(obj, _father) {
        for (const k in obj) {
            this.runOver(k, obj[k], _father);
        }
    }
    /**
     * @param {?} string
     * @return {?}
     */
    isNumber(string) {
        try {
            return true;
        }
        catch (e) {
        }
        return false;
    }
    /**
     * @param {?} id
     * @param {?} value
     * @param {?=} _father
     * @return {?}
     */
    runOver(id, value, _father) {
        for (const k in _father) {
            /** @type {?} */
            const _af = _father[k];
            /** @type {?} */
            const _fId = _af.id;
            if (_fId === undefined) {
                this.runOver(id, value, _af);
            }
            if (id !== _fId) {
                continue;
            }
            if (Array.isArray(_father[k])) ;
            else if (typeof _father[k] === 'object') {
                if (_af.type === 'GROUP' && _af.id === id) {
                    this.fillJsonForm(value, _af.group);
                }
                else if (_af.type === 'ARRAY' && _af.id === id) {
                    /** @type {?} */
                    const isArrayValue = value instanceof Array;
                    /** @type {?} */
                    let length = 0;
                    if (isArrayValue) {
                        _af.groups = [];
                        /** @type {?} */
                        let clone = {};
                        length += ((/** @type {?} */ (value))).length;
                        for (let q = 0; q < length; q++) {
                            clone = JSON.parse(JSON.stringify(_af.groupPrototype));
                            _af.groups.push({ group: clone });
                        }
                        this.superRunObj(value, _af.groups);
                    }
                    _af.initialCount = length + 1;
                }
                else {
                    _father[k].value = value;
                    return;
                }
            }
            else {
                _father[k].value = value;
            }
        }
    }
    /**
     * @param {?} obj
     * @param {?=} _father
     * @return {?}
     */
    superRunObj(obj, _father) {
        /** @type {?} */
        let count = 0;
        if (obj.length === _father.length) {
            /** @type {?} */
            const ll = obj.length;
            for (let i = 0; i < ll; i++) {
                this.fillJsonForm(obj[i], _father[i]);
            }
        }
        else {
            obj.forEach((/**
             * @param {?} item
             * @return {?}
             */
            (item) => {
                console.log(JSON.stringify(item));
                if (typeof item === 'string') {
                    /** @type {?} */
                    const counts = count + '';
                    this.runOver(counts, item, _father);
                }
                else {
                    this.fillJsonForm(item, _father);
                }
                count++;
            }));
        }
    }
    /**
     * @param {?} item
     * @return {?}
     */
    getIcon(item) {
        /** @type {?} */
        let icon = '';
        switch (item.type) {
            case 'ARRAY':
                icon = this.ICON_FOLDER;
                break;
            case 'GROUP':
                icon = this.ICON_GROUP;
                break;
            case 'TEXT':
                icon = this.ICON_input;
                break;
            case 'NUMBER':
                icon = this.ICON_NUMBER;
                break;
            case 'CHECKBOX':
                icon = this.ICON_CHECK;
                break;
            case 'SLIDER':
                icon = this.ICON_CHECK;
                break;
            case 'DATE':
                icon = this.ICON_CHECK;
                break;
            case 'FILE':
                icon = this.ICON_CHECK;
                break;
            case 'RATING':
                icon = this.ICON_CHECK;
                break;
            case 'RADIOBOX':
                icon = this.ICON_CHECK;
                break;
            case 'COMBO':
                icon = this.ICON_CHECK;
                break;
        }
        console.log('type: (' + item.type + ',' + item.inputType + ') ,icon: ' + icon);
        return icon;
    }
}
GuiService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
GuiService.ctorParameters = () => [];
/** @nocollapse */ GuiService.ngInjectableDef = defineInjectable({ factory: function GuiService_Factory() { return new GuiService(); }, token: GuiService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class GformComponent {
    /**
     * @param {?} wikiGuiService
     */
    constructor(wikiGuiService) {
        this.wikiGuiService = wikiGuiService;
        this.root = new MComponent(null);
        this.onSubmit = new EventEmitter();
        this.visTree = false;
        this.formTree = null;
    }
    /**
     * @return {?}
     */
    submit() {
        console.log('submit');
        console.log(this.root.getJson());
        this.onSubmit.emit(this.root.getJson());
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        if (this.structure === undefined && this.data !== undefined) {
            console.log('** LOADING GENERATION FORM**');
            /** @type {?} */
            const jsonForm = [];
            this.wikiGuiService.generateForm(this.data, jsonForm);
            this.structure = jsonForm;
            console.log('** GENERATION FORM COMPLETED **');
        }
        if (this.data !== undefined) {
            console.log('** FILLING FORM FROM JSON**');
            this.wikiGuiService.fillJsonForm(this.data, this.structure);
            console.log('** FILLING COMPLETED  **');
        }
        if (this.structure !== undefined) {
            console.log('** ELABORATION FORM**');
            this.elaboration(this.structure);
            console.log('** ELABORATION COMPLETED **');
        }
    }
    /**
     * @param {?} event
     * @return {?}
     */
    valueChange(event) {
        console.log('(' + event.component.id + ') - ' + ' Value Changed: ' + event.value);
    }
    /**
     * @param {?} json
     * @return {?}
     */
    elaboration(json) {
        json.forEach((/**
         * @param {?} item
         * @return {?}
         */
        (item) => {
            /** @type {?} */
            const icomp = (/** @type {?} */ (item));
            console.log(JSON.stringify(icomp));
            this.root.addChildren(icomp);
        }));
        console.log('elaborazione');
        console.log(JSON.stringify(this.root));
    }
    /**
     * @return {?}
     */
    showTree() {
        this.formTree = this.wikiGuiService.generateTreeForm(this.root);
        this.visTree = true;
    }
    /**
     * @return {?}
     */
    closeTree() {
        this.formTree = null;
        this.visTree = false;
    }
}
GformComponent.decorators = [
    { type: Component, args: [{
                selector: 'wkg-gform',
                template: "<clr-main-container>\n  <wkg-gtree [tree]=\"formTree\" *ngIf=\"visTree\"></wkg-gtree>\n  <form clrForm (ngSubmit)=\"submit()\">\n    <div class=\"card\">\n      <div class=\"card-header\">\n        <button (click)=\"showTree()\" *ngIf=\"!visTree\">Open</button>\n        <button (click)=\"closeTree()\" *ngIf=\"visTree\">Close</button>\n      </div>\n      <div class=\"card-body\">\n        <wkg-glist [component]=\"root\" (onChange)=\"valueChange($event)\"></wkg-glist>\n      </div>\n      <div class=\"card-footer\">\n        <button class=\"btn btn-success\" type=\"submit\">Submit</button>\n        <button class=\"btn btn-warning\" type=\"reset\">Cancel</button>\n      </div>\n    </div>\n    <p>{{ root.getJson() | json}}</p>\n  </form>\n</clr-main-container>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
GformComponent.ctorParameters = () => [
    { type: GuiService }
];
GformComponent.propDecorators = {
    structure: [{ type: Input }],
    data: [{ type: Input }],
    onSubmit: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class GdatagridComponent {
    /**
     * @param {?} wikiGuiService
     */
    constructor(wikiGuiService) {
        this.wikiGuiService = wikiGuiService;
        this.dataGrid = [];
        this.details = false;
        this.designRow = [];
        //  structure: any;
        this.root = new MComponent(null);
        this.dataField = [];
        this.columns = [];
    }
    /**
     * @return {?}
     */
    elaborateFields() {
        /** @type {?} */
        let arrFields = [];
        /** @type {?} */
        let view_field = '';
        /** @type {?} */
        let count = 0;
        if (this.fields !== undefined) {
            arrFields = this.fields.split(',');
            arrFields.forEach((/**
             * @param {?} item
             * @return {?}
             */
            (item) => {
                if (count > 0) {
                    view_field += ',';
                }
                view_field += '[' + item + ']:[' + item + ']';
                count++;
            }));
        }
        /** @type {?} */
        const final_list = [];
        this.dataGrid.forEach((/**
         * @param {?} row
         * @return {?}
         */
        (row) => {
            /** @type {?} */
            let sq = '';
            /** @type {?} */
            let keys = Object.keys(row);
            console.log(JSON.stringify(keys));
            /** @type {?} */
            let full_field = '';
            count = 0;
            keys.forEach((/**
             * @param {?} item
             * @return {?}
             */
            (item) => {
                if (count > 0) {
                    full_field += ',';
                }
                full_field += '[' + item + ']:[' + item + ']';
                count++;
            }));
            console.log(full_field);
            if (this.fields !== undefined) {
                sq = 'SELECT ARRAY({' + view_field + '}) as fields, ARRAY({ ' + full_field + ' }) as structure FROM ? ';
            }
            else {
                sq = 'SELECT ARRAY({' + full_field + '}) as fields, ARRAY({' + full_field + '}) as structure FROM ? ';
            }
            /** @type {?} */
            const app_arr = [row];
            /** @type {?} */
            const app = alasql(sq, [app_arr]);
            console.log(JSON.stringify(app));
            final_list.push(app);
        }));
        this.designRow = final_list;
        this.columns = Object.keys(final_list[0]);
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.elaborateFields();
        console.log('** LOADING GENERATION FORM**');
        /** @type {?} */
        const jsonForm = [];
        this.wikiGuiService.generateForm(this.designRow[0], jsonForm);
        this.structure = jsonForm;
        console.log('** GENERATION FORM COMPLETED **');
        console.log('** FILLING FORM FROM JSON**');
        /*this.wikiGuiService.fillJsonForm(this.dataGrid, this.structure);*/
        console.log('** FILLING COMPLETED  **');
        if (this.structure !== undefined) {
            console.log('** ELABORATION FORM**');
            this.elaboration(this.structure, this.root);
            console.log('** ELABORATION COMPLETED **');
        }
        /*    this.dataGrid.forEach((data) => {
              this.generateComponent(data);
            });*/
        console.log('TABLE LOADING COMPLETED');
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        this.dataGrid = changes.dataGrid.currentValue;
        //console.log('ON CHANGES LINE CHART');
    }
    /**
     * @param {?} json
     * @return {?}
     */
    generateComponent(json) {
        /** @type {?} */
        const row = new MComponent(null);
        console.log('** LOADING GENERATION FORM**');
        /** @type {?} */
        const jsonForm = [];
        this.wikiGuiService.generateForm(json, jsonForm);
        console.log('** GENERATION FORM COMPLETED **');
        console.log('** FILLING FORM FROM JSON**');
        this.wikiGuiService.fillJsonForm(json, jsonForm);
        console.log('** FILLING COMPLETED  **');
        if (this.structure !== undefined) {
            console.log('** ELABORATION FORM**');
            this.elaboration(jsonForm, row);
            console.log('** ELABORATION COMPLETED **');
        }
        this.dataField.push(row);
    }
    /**
     * @param {?} json
     * @param {?} component
     * @return {?}
     */
    elaboration(json, component) {
        json.forEach((/**
         * @param {?} item
         * @return {?}
         */
        (item) => {
            /** @type {?} */
            const icomp = (/** @type {?} */ (item));
            console.log(JSON.stringify(icomp));
            component.addChildren(icomp);
        }));
        console.log('elaborazione');
        console.log(JSON.stringify(component));
    }
}
GdatagridComponent.decorators = [
    { type: Component, args: [{
                selector: 'wkg-gdatagrid',
                template: "<clr-datagrid>\n  <clr-dg-column *ngFor=\"let children of columns\">{{children}}</clr-dg-column>\n  <clr-dg-row *ngFor=\"let row of dataField\">\n    <clr-dg-cell *ngFor=\"let value of row\">{{value.value}}</clr-dg-cell>\n    <ng-template *ngIf=\"details\">\n      <clr-dg-row-detail *clrIfExpanded>\n        <wkg-glist [component]=\"row\"></wkg-glist>\n      </clr-dg-row-detail>\n    </ng-template>\n  </clr-dg-row>\n</clr-datagrid>\n\n",
                styles: [""]
            }] }
];
/** @nocollapse */
GdatagridComponent.ctorParameters = () => [
    { type: GuiService }
];
GdatagridComponent.propDecorators = {
    dataGrid: [{ type: Input }],
    fields: [{ type: Input }],
    details: [{ type: Input }],
    structure: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class TagSelectionComponent {
    constructor() {
        this.item = [];
        this.addItem = new EventEmitter();
        this.removeItem = new EventEmitter();
        this.selectedCustomers = [];
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.title = 'Select a ' + this.description;
        console.log(JSON.stringify(this.item));
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        this.item = changes.item.currentValue;
        //console.log('ON CHANGES LINE CHART');
    }
    /**
     * @param {?} event
     * @return {?}
     */
    clickRow(event) {
        console.log('event clic');
        console.log(event);
        this.addItem.emit(event);
    }
    /**
     * @param {?} event
     * @return {?}
     */
    removeRow(event) {
        console.log('remove event clic');
        console.log(event);
        this.removeItem.emit(event);
    }
}
TagSelectionComponent.decorators = [
    { type: Component, args: [{
                selector: 'wkg-tag-selection',
                template: "<label>Hide selected elements</label>\n<fieldset class=\"form-group\">\n  <ng-select\n    [items]=\"item\"\n    class = \"custom\"\n    [multiple]=\"true\"\n    [closeOnSelect]=\"false\"\n    [hideSelected]=\"true\"\n    bindLabel=\"{{labelField}}\"\n    bindValue=\"{{idField}}\"\n    placeholder=\"{{title}}\"\n    (add)=\"clickRow($event)\"\n    (remove)=\"removeRow($event)\"\n    [(ngModel)]=\"selectedCustomers\">\n  </ng-select>\n</fieldset>\n<!--\n<fieldset class=\"form-group\">\n\n  <ng-select\n    class=\"bootstrap\"\n    (add)=\"clickRow($event)\"\n    (remove)=\"removeRow($event)\"\n    [options]=\"item\"\n    [multiple]=\"multiple\"></ng-select>\n</fieldset>\n-->\n",
                styles: [".ng-dropdown-panel{min-width:100%}.ng-select.custom{border:0;min-height:0;border-radius:0}.ng-select.custom .ng-select-container{min-height:0;border-radius:0}.ng-select.custom ::ng-deep .ng-select-container{min-height:0;border-radius:0}ng-select.ng-invalid.ng-touched .ng-select-container{border-color:#dc3545;box-shadow:inset 0 1px 1px rgba(0,0,0,.075),0 0 0 3px #fde6e8}"]
            }] }
];
/** @nocollapse */
TagSelectionComponent.ctorParameters = () => [];
TagSelectionComponent.propDecorators = {
    item: [{ type: Input }],
    idField: [{ type: Input }],
    labelField: [{ type: Input }],
    multiple: [{ type: Input }],
    description: [{ type: Input }],
    addItem: [{ type: Output }],
    removeItem: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class GuiModule {
}
GuiModule.decorators = [
    { type: NgModule, args: [{
                declarations: [TagSelectionComponent, GObjectComponent, GlistComponent, GtreeComponent, GformComponent, GdatagridComponent],
                exports: [TagSelectionComponent, GObjectComponent, GlistComponent, GtreeComponent, GformComponent, GdatagridComponent],
                providers: [GuiService],
                imports: [
                    CommonModule,
                    FormsModule,
                    ReactiveFormsModule,
                    HttpClientModule,
                    NgSelectModule,
                    ClarityModule,
                    ClrInputModule,
                    ClrCommonFormsModule,
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ReportTotalComponent {
    constructor() {
        this.onClick = new EventEmitter();
        this.close = new EventEmitter();
        this.divView = true;
        this.totalTurnover = 0;
        this.totalGross = 0;
        this.totalPayout = 0;
    }
    /**
     * @return {?}
     */
    closeDiv() {
        this.divView = false;
        this.close.emit('Report Total');
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.elaborate();
    }
    /**
     * @return {?}
     */
    elaborate() {
        this.totalTurnover = 0;
        this.totalGross = 0;
        this.totalPayout = 0;
        /** @type {?} */
        const totals = alasql('SELECT sum(turnover::number) as turnover,' +
            ' sum(gross::number) as gross FROM ? ', [this.reportRow]);
        this.totalTurnover = totals[0].turnover;
        this.totalGross = totals[0].gross;
        this.totalPayout = 1 - (this.totalGross / this.totalTurnover);
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        this.elaborate();
    }
    /**
     * @param {?} event
     * @return {?}
     */
    click(event) {
        this.onClick.emit(event);
    }
}
ReportTotalComponent.decorators = [
    { type: Component, args: [{
                selector: 'wkg-report-total',
                template: "\n<div class=\"row\">\n  <div class=\"col-sm-6 col-lg-3\">\n    <div class=\"card\" (click)=\"click('gross')\">\n      <div class=\"card-body p-3 clearfix\">\n        <i class=\"fa fa-briefcase bg-blue p-3 font-2xl mr-3 float-left\"></i>\n        <div class=\"h5 text-primary mb-0 mt-2\">{{totalTurnover | number:'1.2-2'}}</div>\n        <div class=\"text-muted text-uppercase font-weight-bold font-xs\">Turnover</div>\n      </div>\n    </div>\n  </div><!--/.col-->\n  <div class=\"col-sm-6 col-lg-3\">\n    <div class=\"card\" (click)=\"click('gross')\">\n      <div class=\"card-body p-3 clearfix\">\n        <i class=\"fa fa-google-wallet bg-danger p-3 font-2xl mr-3 float-left\"></i>\n        <div class=\"h5 text-primary mb-0 mt-2\">{{totalGross | number:'1.2-2'}}</div>\n        <div class=\"text-muted text-uppercase font-weight-bold font-xs\">Gross</div>\n      </div>\n    </div>\n  </div><!--/.col-->\n  <div class=\"col-sm-6 col-lg-3\">\n    <div class=\"card\" (click)=\"click('gross')\">\n      <div class=\"card-body p-3 clearfix\">\n        <i class=\"fa fa-fire bg-yellow p-3 font-2xl mr-3 float-left\"></i>\n        <div class=\"h5 text-primary mb-0 mt-2\">{{totalPayout | percent:'2.2-2'}}</div>\n        <div class=\"text-muted text-uppercase font-weight-bold font-xs\">Payout</div>\n      </div>\n    </div>\n  </div><!--/.col-->\n</div>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
ReportTotalComponent.ctorParameters = () => [];
ReportTotalComponent.propDecorators = {
    reportRow: [{ type: Input }],
    onClick: [{ type: Output }],
    close: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ExcelService {
    constructor() { }
    /**
     * @param {?} excelFileName
     * @return {?}
     */
    static toExportFileName(excelFileName) {
        return `${excelFileName}_export_${new Date().getTime()}.xlsx`;
    }
    /**
     * @param {?} json
     * @param {?} excelFileName
     * @return {?}
     */
    exportAsExcelFile(json, excelFileName) {
        /** @type {?} */
        const worksheet = utils.json_to_sheet(json);
        /** @type {?} */
        const workbook = { Sheets: { 'data': worksheet }, SheetNames: ['data'] };
        writeFile(workbook, ExcelService.toExportFileName(excelFileName));
    }
}
ExcelService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
ExcelService.ctorParameters = () => [];
/** @nocollapse */ ExcelService.ngInjectableDef = defineInjectable({ factory: function ExcelService_Factory() { return new ExcelService(); }, token: ExcelService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ReportTableComponent {
    /**
     * @param {?} excelService
     */
    constructor(excelService) {
        this.excelService = excelService;
        // TODO generalizzare e mettere in libreria
        this.rows = [];
        this.clicked = new EventEmitter();
        this.close = new EventEmitter();
        this.inputTopRows = undefined;
        this.hasTop = false;
        this.divView = true;
        this.designRow = [];
        this.progress_color = 'success';
    }
    /**
     * @return {?}
     */
    closeDiv() {
        this.divView = false;
        this.close.emit(this.title);
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.inputTopRows = this.topRows;
        if (this.topRows !== undefined) {
            this.hasTop = false;
        }
        if (this.fields !== undefined) {
            /** @type {?} */
            let sql_1 = 'SELECT ' + this.fields + ' FROM ?';
            sql_1 += ' ORDER BY ' + this.amount + ' DESC ';
            //    console.log(sql_2);
            this.designRow = alasql(sql_1, [this.rows]);
        }
        else {
            this.elaborate();
        }
    }
    /**
     * @return {?}
     */
    elaborate() {
        if (this.rows === undefined || this.rows.length === 0) {
            this.designRow = null;
            return;
        }
        switch (this.color) {
            case 'green':
                this.progress_color = 'success';
                break;
            case 'red':
                this.progress_color = 'alert';
                break;
            case 'blue':
                this.progress_color = 'active';
                break;
            case 'yellow':
                this.progress_color = 'danger';
                break;
            default:
                this.progress_color = 'active';
                break;
        }
        /** @type {?} */
        const sql_1 = 'SELECT sum(' + this.amount + '::number) as amount FROM ?';
        /** @type {?} */
        const totals = alasql(sql_1, [this.rows]);
        this.totalAmount = totals[0].amount;
        //console.log('totalTurnover = ' + this.totalAmount);
        /** @type {?} */
        let count_amount = 1;
        /** @type {?} */
        let sql_2 = 'SELECT "' + this.owner_id + '" as owner_id,';
        count_amount++;
        if (this.owner_id !== undefined && this.owner_id.length > 0) {
            sql_2 += this.owner_id + ' as id,';
            count_amount++;
        }
        if (this.owner !== undefined && this.owner.length > 0) {
            sql_2 += this.owner + ' as name, ';
            count_amount++;
        }
        if (this.owner_img !== undefined && this.owner_img.length > 0) {
            sql_2 += '"' + this.owner_img + '"+' + this.owner_id + '+".png" as img, ';
            count_amount++;
        }
        sql_2 += 'sum(' + this.amount + '::number) as amount,';
        sql_2 += '(sum(' + this.amount + '::number)/?) as ms_amount';
        sql_2 += ' FROM ? ';
        sql_2 += 'GROUP BY ';
        if (this.owner_id !== undefined && this.owner.length > 0) {
            sql_2 += this.owner_id + ', ';
        }
        if (this.owner_id !== undefined && this.owner_id.length > 0) {
            sql_2 += this.owner;
        }
        sql_2 += ' ORDER BY ' + count_amount + ' DESC ';
        //    console.log(sql_2);
        /** @type {?} */
        const arr = alasql(sql_2, [this.totalAmount, this.rows]);
        /** @type {?} */
        const arr2 = this.regroupSingle(arr);
        this.designRow = arr2;
    }
    /**
     * @param {?} arr
     * @return {?}
     */
    regroupSingle(arr) {
        /** @type {?} */
        const len_arr = arr.length;
        /** @type {?} */
        let top_rows = 0;
        if (this.inputTopRows !== undefined) {
            top_rows = this.inputTopRows + 1;
        }
        if (this.inputTopRows === undefined) {
            return arr;
        }
        else if (len_arr > top_rows) {
            console.log('REGROUP SINGLE ' + JSON.stringify(arr));
            /** @type {?} */
            let sql_string = 'SELECT TOP ' + this.inputTopRows + ' id as id, name as name, amount  as [amount], ms_amount  as [ms_amount]  FROM ? ORDER BY amount DESC';
            console.log('SELECT TOP ' + sql_string);
            /** @type {?} */
            const top = alasql(sql_string, [arr]);
            console.log('SELECT TOP ' + sql_string);
            sql_string = 'SELECT id FROM ? ';
            console.log('SELECT TOP ' + sql_string);
            /** @type {?} */
            const top_id = alasql(sql_string, [top]);
            sql_string = 'SELECT "others" as id, "others"  as name, SUM(amount ::number) as [amount], SUM(ms_amount ::number) as [ms_amount]  FROM ? WHERE id NOT IN (SELECT id FROM ? )';
            console.log('SELECT TOP ' + sql_string);
            /** @type {?} */
            const rest = alasql(sql_string, [arr, top_id]);
            rest.forEach((/**
             * @param {?} item
             * @return {?}
             */
            (item) => {
                top.push(item);
            }));
            return top;
        }
        else {
            return arr;
        }
    }
    /**
     * @param {?=} numTop
     * @return {?}
     */
    filterTop(numTop) {
        if (numTop === undefined) {
            this.inputTopRows = undefined;
            this.elaborate();
        }
        else {
            this.inputTopRows = numTop;
            this.elaborate();
        }
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        //    console.log(JSON.stringify(changes));
        if (changes.rows !== undefined) {
            this.rows = changes.rows.currentValue;
            this.elaborate();
        }
    }
    /**
     * @param {?} element
     * @return {?}
     */
    clickRow(element) {
        console.log('table clicked ' + element);
        console.log(JSON.stringify(element));
        this.clicked.emit(element);
    }
    /**
     * @return {?}
     */
    exportExcel() {
        this.excelService.exportAsExcelFile(this.rows, 'table');
    }
}
ReportTableComponent.decorators = [
    { type: Component, args: [{
                selector: 'wkg-report-table',
                template: "<div class=\"animated fadeIn\">\n  <div class=\"row\" *ngIf=\"designRow\">\n    <div class=\"col-md-6 mb-4\">\n      <div class=\"card\">\n        <div class=\"card-header\">\n          <i class=\"icon-list\"></i> {{title | uppercase}}   -   {{amount | uppercase}}\n          <div class=\"card-actions\">\n            <label class=\"btn btn-outline-success \" (click)=\"filterTop(inputTopRows)\" *ngIf=\"!inputTopRows && hasTop\">Top {{topRows}}</label>\n            <label class=\"btn btn-outline-success \" (click)=\"filterTop(5)\" *ngIf=\"!inputTopRows && !hasTop\">Top 5</label>\n            <label class=\"btn btn-outline-success \" (click)=\"filterTop()\" *ngIf=\"inputTopRows\">Others</label>\n            <button type=\"button\" class=\"close\" aria-label=\"Close\" (click)=\"closeDiv()\">\n              <span aria-hidden=\"true\">&times;</span>\n            </button>\n          </div>\n        </div>\n        <div class=\"card-body\">\n          <table class=\"table table-responsive-sm table-hover table-outline mb-0\">\n            <thead class=\"thead-light\">\n            <tr>\n              <th>Name</th>\n              <th>Market Share</th>\n              <th>Amount</th>\n            </tr>\n            </thead>\n            <tbody>\n            <tr *ngFor=\"let r of designRow\" (click)=\"clickRow(r)\">\n              <td>\n                <div>{{r.name}}</div>\n              </td>\n              <td>\n                <div class=\"clearfix\">\n                  <div class=\"float-left\">\n                    <strong>{{r.ms_amount | percent:'2.2-2'}}</strong>\n                  </div>\n                </div>\n                <div>\n                  <progressbar class=\"progress progress-success\" [value]=\"r.ms_amount\" [max]=\"1\"\n                               type=\"{{progress_color}}\"></progressbar>\n                </div>\n              </td>\n              <td>\n                <div>{{r.amount | number:'1.2-2'}}</div>\n              </td>\n            </tr>\n            </tbody>\n          </table>\n        </div>\n        <div class=\"card-footer\">\n          <button type=\"button\" (click)=\"exportExcel()\">Export Excel</button>\n        </div>\n      </div>\n    </div><!--/.col-->\n  </div>\n</div>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
ReportTableComponent.ctorParameters = () => [
    { type: ExcelService }
];
ReportTableComponent.propDecorators = {
    rows: [{ type: Input }],
    amount: [{ type: Input }],
    owner: [{ type: Input }],
    owner_id: [{ type: Input }],
    owner_img: [{ type: Input }],
    fields: [{ type: Input }],
    topRows: [{ type: Input }],
    color: [{ type: Input }],
    title: [{ type: Input }],
    clicked: [{ type: Output }],
    close: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class LineChartComponent {
    constructor() {
        this.lineChartData = new Array();
        this.lineChartLabels = new Array();
        this.legend = false;
        this.onHovered = new EventEmitter();
        this.onClicked = new EventEmitter();
        this.chartOptions = {
            animation: false,
            responsive: true
        };
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @param {?} e
     * @return {?}
     */
    chartClicked(e) {
        console.log(JSON.stringify(e));
        this.onClicked.emit(e);
    }
    /**
     * @param {?} e
     * @return {?}
     */
    chartHovered(e) {
        console.log(JSON.stringify(e));
        this.onHovered.emit(e);
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        this.lineChartData = changes.lineChartData.currentValue;
        this.lineChartLabels = changes.lineChartLabels.currentValue;
    }
}
LineChartComponent.decorators = [
    { type: Component, args: [{
                selector: 'wkg-line-chart',
                template: "<canvas baseChart class=\"chart\"\n        [datasets]=\"lineChartData\"\n        [labels]=\"lineChartLabels\"\n        [chartType]=\"'line'\"\n        [legend]=\"legend\"\n        [options]=\"chartOptions\"\n        (chartHover)=\"chartHovered($event)\"\n        (chartClick)=\"chartClicked($event)\"></canvas>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
LineChartComponent.ctorParameters = () => [];
LineChartComponent.propDecorators = {
    lineChartData: [{ type: Input }],
    lineChartLabels: [{ type: Input }],
    legend: [{ type: Input }],
    onHovered: [{ type: Output }],
    onClicked: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ChartComponent {
    constructor() {
        this.rows = [];
        this.legend = false;
        this.chartType = 'line';
        this.minimal = true;
        this.yAxisLabel = 'GDP Per Capita';
        this.xAxisLabel = 'Country';
        this.debug = false;
        this.onClick = new EventEmitter();
        this.close = new EventEmitter();
        this.designRow = [];
        this.showRefLines = true;
        this.showRefLabels = true;
        this.autoScale = true;
        this.timeline = false;
        this.showXAxis = true;
        this.showYAxis = true;
        this.gradient = false;
        this.legendTitle = 'Legend';
        this.legendPosition = 'right';
        this.showXAxisLabel = true;
        this.tooltipDisabled = false;
        this.showYAxisLabel = true;
        this.showGridLines = true;
        this.innerPadding = '10%';
        this.barPadding = 8;
        this.groupPadding = 16;
        this.roundDomains = false;
        this.maxRadius = 10;
        this.minRadius = 3;
        this.animations = true;
        this.showSeriesOnHover = true;
        this.roundEdges = true;
        this.rangeFillOpacity = 0.15;
        this.showDataLabel = false;
        this.schemeType = 'ordinal';
        this.width = 700;
        this.height = 300;
        this.show = true;
        this.fitContainer = false;
        this.view = undefined; //[700, 300];
        //[700, 300];
        this.hasTop = false;
        this.inputTopRows = undefined;
        this.divView = true;
        this.chartOptions = {
            animation: false,
            responsive: true
        };
        this.chartLabel = [];
        this.chartData = [];
        this.lineChartData = new Array();
        this.lineChartLabels = new Array();
        this.minimalChartType = 'doughnut';
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.inputTopRows = this.topRows;
        if (this.topRows !== undefined) {
            this.hasTop = false;
        }
        // this.elaborate();                                                   // do something if it exists, fo sho
    }
    /**
     * @return {?}
     */
    elaborate() {
        if (this.rows === undefined) {
            this.designRow = null;
            return;
        }
        /** @type {?} */
        let app2 = [];
        switch (this.chartType) {
            case 'donut':
                this.minimalChartType = 'doughnut';
                app2 = this.singleChart();
                if (this.minimal) {
                    this.drawChart(app2);
                }
                break;
            case 'pie':
                this.minimalChartType = 'pie';
                app2 = this.singleChart();
                if (this.minimal) {
                    this.drawChart(app2);
                }
                break;
            case 'line':
                this.minimalChartType = 'line';
                app2 = this.seriesChart();
                if (this.minimal) {
                    this.drawChartSeries(app2);
                }
                break;
            default:
                this.minimalChartType = this.chartType;
                app2 = this.seriesChart();
                break;
        }
        this.designRow = app2;
        if (this.debug) {
            console.log('DATACHART: ' + JSON.stringify(this.designRow));
            if (this.minimal) {
                console.log('DATA: ' + JSON.stringify(this.chartData));
                console.log('LABEL: ' + JSON.stringify(this.chartLabel));
                console.log('DATA_LINE: ' + JSON.stringify(this.lineChartData));
                console.log('LABEL_LINE: ' + JSON.stringify(this.lineChartLabels));
            }
        }
    }
    /**
     * @param {?} arr
     * @return {?}
     */
    drawChartSeries(arr) {
        /*this.chartData = null;
            this.chartLabel = null;*/
        /** @type {?} */
        let _lineChartData = new Array();
        /** @type {?} */
        let _lineChartLabels = new Array();
        // result = [["value1", "value2"], ["value3", "value4"]]
        if (this.debug) {
            console.log('arr: ' + JSON.stringify(arr));
        }
        /** @type {?} */
        const label = [];
        /** @type {?} */
        const sql_string = 'SELECT distinct ' + this.period + ' as date FROM ? GROUP BY ' + this.period + ' ORDER BY ' + this.period + ' DESC';
        /** @type {?} */
        let dates = alasql(sql_string, [this.rows]);
        // app = this.regroup(app);
        /*const app2 = alasql('SELECT distinct date as label, name as name, ARRAY({[value]:[amount]}) AS series FROM ? GROUP BY date,name ORDER BY date DESC', [app]);
        console.log('data: ' + JSON.stringify(app2));*/
        arr.forEach((/**
         * @param {?} cust
         * @return {?}
         */
        (cust) => {
            //    {data: [65, 59, 80, 81, 56, 55, 40], label: 'Series A'},
            /** @type {?} */
            const series = cust.series;
            /** @type {?} */
            const arr_app = new Array();
            dates.forEach((/**
             * @param {?} d
             * @return {?}
             */
            (d) => {
                /** @type {?} */
                let val = alasql('SELECT [value] as amount FROM ? WHERE name = ?', [series, d.date]);
                if (val === undefined || val === null || val.length === 0) {
                    val = [{ amount: 0 }];
                }
                // console.log(cust.name + ' - ' + d.date + ' - ' + JSON.stringify(val));
                /** @type {?} */
                const obj = { name: cust.name, date: d.date, value: val[0].amount };
                arr_app.push(val[0].amount);
            }));
            /** @type {?} */
            const crow = { label: cust.name, data: arr_app };
            _lineChartData.push(crow);
            console.log('customer: ' + cust.name + ' -> ' + JSON.stringify(crow));
        }));
        dates.forEach((/**
         * @param {?} d
         * @return {?}
         */
        (d) => {
            _lineChartLabels.push(d.date);
        }));
        if (this.debug) {
            console.log('label: ' + JSON.stringify(_lineChartLabels));
            console.log('data: ' + JSON.stringify(_lineChartData));
        }
        console.log('label: ' + JSON.stringify(label));
        this.lineChartData = _lineChartData;
        this.lineChartLabels = _lineChartLabels;
    }
    /**
     * @param {?} arr
     * @return {?}
     */
    drawChart(arr) {
        this.chartData = [];
        this.chartLabel = [];
        /** @type {?} */
        const _lineChartData = [];
        /** @type {?} */
        const _lineChartLabels = [];
        arr.forEach((/**
         * @param {?} item
         * @return {?}
         */
        (item) => {
            _lineChartLabels.push(item.name);
            _lineChartData.push(item.value);
        }));
        this.chartData = _lineChartData;
        this.chartLabel = _lineChartLabels;
    }
    /**
     * @return {?}
     */
    seriesChart() {
        /** @type {?} */
        let app2 = null;
        if (!this.rows[0].hasOwnProperty(this.period)) { // true
            return app2;
        }
        /** @type {?} */
        const sql_string = 'SELECT ' + this.owner_id + ' AS id, ' + this.owner + ' AS name, ' + this.period +
            ' as date,SUM(' + this.amount + '::number) AS amount FROM ? GROUP BY ' + this.owner_id + ', ' + this.owner + ', ' + this.period + ' ORDER BY ' + this.period;
        /** @type {?} */
        let app = alasql(sql_string, [this.rows]);
        app = this.regroup(app);
        if (this.debug) {
            console.log('SELECT CHART: ' + sql_string);
        }
        app2 = alasql('SELECT name, ARRAY({[name]:[date],[value]:[amount]}) AS series FROM ? GROUP BY name', [app]);
        return app2;
    }
    /**
     * @param {?} arr
     * @return {?}
     */
    regroupSingle(arr) {
        /** @type {?} */
        const len_arr = arr.length;
        /** @type {?} */
        let top_rows = 0;
        if (this.inputTopRows !== undefined) {
            top_rows = this.inputTopRows + 1;
        }
        if (this.inputTopRows === undefined) {
            return arr;
        }
        else if (len_arr > top_rows) {
            if (this.debug) {
                console.log('REGROUP SINGLE ' + JSON.stringify(arr));
            }
            /** @type {?} */
            let sql_string = 'SELECT TOP ' + this.inputTopRows + ' name as id, [name] as [name], [value] as [value] FROM ? ORDER BY value DESC';
            if (this.debug) {
                console.log('SELECT TOP ' + sql_string);
            }
            /** @type {?} */
            const top = alasql(sql_string, [arr]);
            if (this.debug) {
                console.log('ARR TOP ' + top);
            }
            sql_string = 'SELECT id FROM ? ';
            //      console.log('SELECT TOP ' + sql_string);
            /** @type {?} */
            const top_id = alasql(sql_string, [top]);
            sql_string = 'SELECT "others" as id, "others"  as name, SUM(value ::number) as [value]  FROM ? WHERE id NOT IN (SELECT id FROM ? )';
            if (this.debug) {
                console.log('SELECT TOP ' + sql_string);
            }
            /** @type {?} */
            const rest = alasql(sql_string, [arr, top_id]);
            rest.forEach((/**
             * @param {?} item
             * @return {?}
             */
            (item) => {
                top.push(item);
            }));
            return top;
        }
        else {
            return arr;
        }
    }
    /**
     * @param {?} arr
     * @return {?}
     */
    regroup(arr) {
        /** @type {?} */
        const len_arr = arr.length;
        /** @type {?} */
        let top_rows = 0;
        if (this.inputTopRows !== undefined) {
            top_rows = this.inputTopRows + 1;
        }
        if (this.inputTopRows === undefined) {
            return arr;
        }
        else {
            if (this.debug) {
                console.log('REGROUP SERIES ' + JSON.stringify(arr));
            }
            //console.log('REGROUP SINGLE ' + JSON.stringify(arr));
            /** @type {?} */
            const sql_top = 'SELECT id as id, name as name,  SUM(amount::number) as amount FROM ? GROUP BY id, name';
            if (this.debug) {
                console.log('SELECT TOP ' + sql_top);
            }
            /** @type {?} */
            const totals = alasql(sql_top, [arr]);
            /** @type {?} */
            let sql_string = 'SELECT TOP ' + this.inputTopRows + ' [id] as [id], [name] as [name],  [amount] as [amount] FROM ? ORDER BY  amount DESC';
            if (this.debug) {
                console.log('SELECT TOP ' + sql_string);
            }
            /** @type {?} */
            let top = alasql(sql_string, [totals]);
            if (this.debug) {
                console.log('ARR TOP ' + JSON.stringify(top));
            }
            /*      sql_string = 'SELECT id FROM ? ';
                  //console.log('SELECT TOP ' + sql_string);
                  const top_id = alasql(sql_string, [top]);
            */
            sql_string = 'SELECT id as id, name as name, date as date, amount as amount FROM ? WHERE id IN (SELECT id FROM ?)';
            if (this.debug) {
                console.log('SELECT TOP ' + sql_string);
            }
            top = alasql(sql_string, [arr, top]);
            sql_string = 'SELECT "others" as id, "others"  as name, date as date, SUM(amount::number) as amount FROM ? WHERE id NOT IN (SELECT id FROM ? ) GROUP BY date';
            //console.log('SELECT TOP ' + sql_string);
            /** @type {?} */
            const rest = alasql(sql_string, [arr, top]);
            if (this.debug) {
                console.log('ARR TOP OTHERS' + JSON.stringify(rest));
            }
            rest.forEach((/**
             * @param {?} item
             * @return {?}
             */
            (item) => {
                top.push(item);
            }));
            return top;
        }
    }
    /**
     * @return {?}
     */
    singleChart() {
        /** @type {?} */
        const sql_string = 'SELECT ' + this.owner + ' AS [name],' +
            'SUM(' + this.amount + '::number) AS [value]' +
            ' FROM ? GROUP BY ' + this.owner;
        /** @type {?} */
        let app = alasql(sql_string, [this.rows]);
        if (this.debug) {
            console.log('PREFILTER : ' + JSON.stringify(app));
        }
        app = this.regroupSingle(app);
        if (this.debug) {
            console.log('SELECT CHART: ' + sql_string);
            console.log('SELECT CHART ARRAY: ' + JSON.stringify(app));
        }
        return app;
    }
    /**
     * @param {?=} numTop
     * @return {?}
     */
    filterTop(numTop) {
        if (numTop === undefined) {
            this.inputTopRows = undefined;
            this.elaborate();
        }
        else {
            this.inputTopRows = numTop;
            this.elaborate();
        }
    }
    /**
     * @param {?} entry
     * @return {?}
     */
    onLegendLabelClick(entry) {
        console.log('Legend clicked', entry);
        this.onClick.emit(entry);
    }
    /**
     * @param {?} data
     * @return {?}
     */
    select(data) {
        console.log('Item clicked', data);
        this.onClick.emit(data);
    }
    /**
     * @param {?} event
     * @return {?}
     */
    dblclick(event) {
        console.log('Doube click', event);
        this.onClick.emit(event);
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        this.rows = changes.rows.currentValue;
        if (this.debug) {
            console.log('ON CHANGES LINE CHART');
        }
        this.elaborate();
    }
    /**
     * @return {?}
     */
    closeDiv() {
        this.divView = false;
        this.close.emit(this.title);
    }
    /**
     * @param {?} e
     * @return {?}
     */
    chartClicked(e) {
        console.log(JSON.stringify(e));
    }
    /**
     * @param {?} e
     * @return {?}
     */
    chartHovered(e) {
        console.log(JSON.stringify(e));
    }
}
ChartComponent.decorators = [
    { type: Component, args: [{
                selector: 'wkg-chart',
                template: "<div class=\"card\" *ngIf=\"designRow && divView\">\n  <div class=\"card-header\">\n    {{title}}\n    <div class=\"card-actions\">\n      <label class=\"btn btn-outline-success \" (click)=\"filterTop(inputTopRows)\" *ngIf=\"!inputTopRows && hasTop\">Top {{topRows}}</label>\n      <label class=\"btn btn-outline-success \" (click)=\"filterTop(5)\" *ngIf=\"!inputTopRows && !hasTop\">Top 5</label>\n      <label class=\"btn btn-outline-success \" (click)=\"filterTop()\" *ngIf=\"inputTopRows\">Others</label>\n      <button type=\"button\" class=\"close\" aria-label=\"Close\" (click)=\"closeDiv()\">\n        <span aria-hidden=\"true\">&times;</span>\n      </button>\n\n    </div>\n  </div>\n  <div class=\"card-body\">\n    <div *ngIf=\"minimal; else classic\">\n      <div class=\"chart-wrapper\" [ngSwitch]=\"chartType\">\n        <div *ngSwitchCase=\"'line'\">\n          <canvas baseChart class=\"chart\" *ngIf=\"lineChartData\"\n                  [datasets]=\"lineChartData\"\n                  [labels]=\"lineChartLabels\"\n                  [chartType]=\"'line'\"\n                  [legend]=\"legend\"\n                  [options]=\"chartOptions\"\n                  (chartHover)=\"chartHovered($event)\"\n                  (chartClick)=\"chartClicked($event)\"></canvas>\n\n        </div>\n\n        <canvas baseChart class=\"chart\" *ngSwitchCase=\"'pie'\"\n                [data]=\"chartData\"\n                [labels]=\"chartLabel\"\n                [chartType]=\"minimalChartType\"\n                [options]=\"chartOptions\"\n                [legend]=\"legend\"\n                (chartHover)=\"chartHovered($event)\"\n                (chartClick)=\"chartClicked($event)\"></canvas>\n        <canvas baseChart class=\"chart\" *ngSwitchCase=\"'donut'\"\n                [data]=\"chartData\"\n                [labels]=\"chartLabel\"\n                [chartType]=\"minimalChartType\"\n                [options]=\"chartOptions\"\n                [legend]=\"legend\"\n                (chartHover)=\"chartHovered($event)\"\n                (chartClick)=\"chartClicked($event)\"></canvas>\n\n      </div>\n    </div>\n\n    <ng-template #classic>\n      <div [ngSwitch]=\"chartType\">\n        <ngx-charts-pie-chart *ngSwitchCase=\"'pie'\"\n                              class=\"chart-container\"\n                              [view]=\"view\"\n                              [results]=\"designRow\"\n                              [animations]=\"animations\"\n                              [legend]=\"legend\"\n                              [legendTitle]=\"legendTitle\"\n                              [legendPosition]=\"legendPosition\"\n                              [labels]=\"'true'\"\n                              (legendLabelClick)=\"onLegendLabelClick($event)\"\n                              [gradient]=\"gradient\"\n                              [tooltipDisabled]=\"tooltipDisabled\"\n                              (dblclick)=\"dblclick($event)\"\n                              (select)=\"select($event)\">\n        </ngx-charts-pie-chart>\n        <ngx-charts-pie-chart *ngSwitchCase=\"'donut'\"\n                              class=\"chart-container\"\n                              [results]=\"designRow\"\n                              [legend]=\"legend\"\n                              [legendTitle]=\"legendTitle\"\n                              [legendPosition]=\"legendPosition\"\n                              [labels]=\"'true'\"\n                              [doughnut]=\"'true'\"\n                              (legendLabelClick)=\"onLegendLabelClick($event)\"\n                              [gradient]=\"gradient\"\n                              [tooltipDisabled]=\"tooltipDisabled\"\n                              (dblclick)=\"dblclick($event)\"\n                              (select)=\"select($event)\">\n        </ngx-charts-pie-chart>\n        <ngx-charts-line-chart *ngSwitchCase=\"'line'\"\n                               class=\"chart-container\"\n                               [schemeType]=\"schemeType\"\n                               [results]=\"designRow\"\n                               [legend]=\"legend\"\n                               [legendTitle]=\"legendTitle\"\n                               [legendPosition]=\"legendPosition\"\n                               (legendLabelClick)=\"onLegendLabelClick($event)\"\n                               [gradient]=\"gradient\"\n                               [xAxis]=\"showXAxis\"\n                               [yAxis]=\"showYAxis\"\n                               [showXAxisLabel]=\"showXAxisLabel\"\n                               [showYAxisLabel]=\"showYAxisLabel\"\n                               [xAxisLabel]=\"xAxisLabel\"\n                               [yAxisLabel]=\"yAxisLabel\"\n                               [autoScale]=\"autoScale\"\n                               [xScaleMin]=\"xScaleMin\"\n                               [xScaleMax]=\"xScaleMax\"\n                               [yScaleMin]=\"yScaleMin\"\n                               [yScaleMax]=\"yScaleMax\"\n                               [timeline]=\"timeline\"\n                               [showGridLines]=\"showGridLines\"\n                               [rangeFillOpacity]=\"rangeFillOpacity\"\n                               (select)=\"select($event)\">\n        </ngx-charts-line-chart>\n        <ngx-charts-bar-vertical-stacked *ngSwitchCase=\"'stack-vertical'\"\n                                         class=\"chart-container\"\n                                         [view]=\"view\"\n                                         [schemeType]=\"schemeType\"\n                                         [results]=\"designRow\"\n                                         [animations]=\"animations\"\n                                         [gradient]=\"gradient\"\n                                         [tooltipDisabled]=\"tooltipDisabled\"\n                                         [xAxis]=\"showXAxis\"\n                                         [yAxis]=\"showYAxis\"\n                                         [legend]=\"legend\"\n                                         [legendTitle]=\"legendTitle\"\n                                         [legendPosition]=\"legendPosition\"\n                                         (legendLabelClick)=\"onLegendLabelClick($event)\"\n                                         [showXAxisLabel]=\"showXAxisLabel\"\n                                         [showYAxisLabel]=\"showYAxisLabel\"\n                                         [xAxisLabel]=\"xAxisLabel\"\n                                         [yAxisLabel]=\"yAxisLabel\"\n                                         [showGridLines]=\"showGridLines\"\n                                         [barPadding]=\"barPadding\"\n                                         [roundDomains]=\"roundDomains\"\n                                         [yScaleMax]=\"yScaleMax\"\n                                         [showDataLabel]=\"showDataLabel\"\n                                         (select)=\"select($event)\">\n        </ngx-charts-bar-vertical-stacked>\n        <ngx-charts-bar-horizontal-stacked *ngSwitchCase=\"'stack-horizontal'\"\n                                           class=\"chart-container\"\n                                           [view]=\"view\"\n                                           [schemeType]=\"schemeType\"\n                                           [results]=\"designRow\"\n                                           [animations]=\"animations\"\n                                           [gradient]=\"gradient\"\n                                           [tooltipDisabled]=\"tooltipDisabled\"\n                                           [xAxis]=\"showXAxis\"\n                                           [yAxis]=\"showYAxis\"\n                                           [legend]=\"legend\"\n                                           [legendTitle]=\"legendTitle\"\n                                           [legendPosition]=\"legendPosition\"\n                                           (legendLabelClick)=\"onLegendLabelClick($event)\"\n                                           [showXAxisLabel]=\"showXAxisLabel\"\n                                           [showYAxisLabel]=\"showYAxisLabel\"\n                                           [xAxisLabel]=\"xAxisLabel\"\n                                           [yAxisLabel]=\"yAxisLabel\"\n                                           [showGridLines]=\"showGridLines\"\n                                           [barPadding]=\"barPadding\"\n                                           [roundDomains]=\"roundDomains\"\n                                           [showDataLabel]=\"showDataLabel\"\n                                           (select)=\"select($event)\">\n        </ngx-charts-bar-horizontal-stacked>\n        <div *ngSwitchDefault> Default {{chartType}}</div>\n      </div>\n    </ng-template>\n  </div>\n</div>\n\n",
                styles: [""]
            }] }
];
/** @nocollapse */
ChartComponent.ctorParameters = () => [];
ChartComponent.propDecorators = {
    rows: [{ type: Input }],
    owner: [{ type: Input }],
    owner_id: [{ type: Input }],
    topRows: [{ type: Input }],
    period: [{ type: Input }],
    legend: [{ type: Input }],
    title: [{ type: Input }],
    amount: [{ type: Input }],
    chartType: [{ type: Input }],
    minimal: [{ type: Input }],
    yAxisLabel: [{ type: Input }],
    xAxisLabel: [{ type: Input }],
    debug: [{ type: Input }],
    onClick: [{ type: Output }],
    close: [{ type: Output }],
    lineChart: [{ type: ViewChild, args: [LineChartComponent,] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NumberChartComponent {
    //[700, 300];
    constructor() {
        this.rows = [];
        this.onClick = new EventEmitter();
        this.close = new EventEmitter();
        this.divView = true;
        this.autoScale = true;
        this.timeline = false;
        this.showXAxis = true;
        this.showYAxis = true;
        this.gradient = false;
        this.legendTitle = 'Legend';
        this.legendPosition = 'right';
        this.showXAxisLabel = true;
        this.tooltipDisabled = false;
        this.showYAxisLabel = true;
        this.showGridLines = true;
        this.innerPadding = '10%';
        this.barPadding = 8;
        this.groupPadding = 16;
        this.roundDomains = false;
        this.maxRadius = 10;
        this.minRadius = 3;
        this.animations = true;
        this.showSeriesOnHover = true;
        this.roundEdges = true;
        this.rangeFillOpacity = 0.15;
        this.showDataLabel = false;
        this.schemeType = 'ordinal';
        this.width = 700;
        this.height = 300;
        this.show = true;
        this.fitContainer = false;
        this.view = undefined; //[700, 300];
    }
    /**
     * @return {?}
     */
    closeDiv() {
        this.divView = false;
        this.close.emit(this.title);
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        console.log('INIT');
    }
    /**
     * @param {?} entry
     * @return {?}
     */
    onLegendLabelClick(entry) {
        console.log('Legend clicked', entry);
        this.onClick.emit(entry);
    }
    /**
     * @param {?} data
     * @return {?}
     */
    select(data) {
        console.log('Item clicked', data);
        this.onClick.emit(data);
    }
    /**
     * @param {?} event
     * @return {?}
     */
    dblclick(event) {
        console.log('Doube click', event);
        this.onClick.emit(event);
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        this.rows = changes.rows.currentValue;
        //console.log('ON CHANGES LINE CHART');
    }
}
NumberChartComponent.decorators = [
    { type: Component, args: [{
                selector: 'wkg-number-chart',
                template: "<div class=\"card\">\n  <div class=\"card-header\">\n    {{title}}\n    <div class=\"card-actions\">\n      <a (click)=\"closeDiv()\">\n        <small class=\"text-muted\">X</small>\n      </a>\n    </div>\n  </div>\n  <div class=\"card-body\" >\n    <ngx-charts-number-card\n                          [results]=\"rows\"\n                          (onClick)=\"select($event)\">\n    </ngx-charts-number-card>\n  </div>\n</div>\n\n",
                styles: [""]
            }] }
];
/** @nocollapse */
NumberChartComponent.ctorParameters = () => [];
NumberChartComponent.propDecorators = {
    rows: [{ type: Input }],
    title: [{ type: Input }],
    onClick: [{ type: Output }],
    close: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class WbiModule {
}
WbiModule.decorators = [
    { type: NgModule, args: [{
                declarations: [ReportTotalComponent, ReportTableComponent, ChartComponent, NumberChartComponent, LineChartComponent],
                exports: [ReportTotalComponent, ReportTableComponent, ChartComponent, NumberChartComponent],
                imports: [
                    CommonModule,
                    TabsModule,
                    FormsModule,
                    ReactiveFormsModule,
                    ProgressbarModule.forRoot(),
                    ChartsModule,
                    ClarityModule,
                    LineChartModule,
                    BarChartModule,
                    PieChartModule,
                    NumberCardModule,
                    NgSelectModule,
                    ClarityModule,
                    ClrInputModule,
                    ClrCommonFormsModule
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class WikigiocoLibModule {
}
WikigiocoLibModule.decorators = [
    { type: NgModule, args: [{
                declarations: [WikigiocoLibComponent],
                imports: [
                    GuiModule,
                    NoopAnimationsModule,
                    BrowserAnimationsModule,
                    WbiModule
                ],
                exports: [WikigiocoLibComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MFilter {
    /**
     * @param {?} key
     * @param {?} value
     * @param {?=} description
     * @param {?=} object
     */
    constructor(key, value, description, object) {
        this.key = key;
        this.value = value;
        this.description = description;
        this.object = object;
    }
    /**
     * @param {?} filter
     * @return {?}
     */
    equals(filter) {
        if (this.key === filter.key && this.value === filter.value) {
            return true;
        }
        else {
            return false;
        }
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MComparator {
    /**
     * @param {?} title
     * @param {?} owner
     * @param {?=} owner_id
     * @param {?=} owner_path
     */
    constructor(title, owner, owner_id, owner_path) {
        this.title = title;
        this.owner = owner;
        this.owner_id = owner_id;
        this.owner_path = owner_path;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { WikigiocoLibService, WikigiocoLibComponent, WikigiocoLibModule, GlistComponent, GtreeComponent, TreeNode, GdatagridComponent, MComponent, GuiService, GObjectComponent, TagSelectionComponent, GformComponent, GuiModule, WbiModule, ExcelService, ChartComponent, ReportTableComponent, ReportTotalComponent, MFilter, MComparator, LineChartComponent as ɵa, NumberChartComponent as ɵb };

//# sourceMappingURL=wikigioco-lib.js.map